Index: EcnlProtoTool/trunk/asp3_dcre/include/sil.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/include/sil.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/include/sil.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2011 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -276,4 +276,72 @@
 #endif /* TOPPERS_OMIT_SIL_ACCESS */
 
+#ifndef TOPPERS_OMIT_SIL_SYNC_WRITE
+
+/*
+ *  8ビット単位の同期書込み
+ */
+#ifdef UINT8_MAX
+
+Inline void
+sil_swrb_mem(uint8_t *mem, uint8_t data)
+{
+	sil_wrb_mem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+#endif /* UINT8_MAX */
+
+/*
+ *  16ビット単位の同期書込み
+ */
+
+Inline void
+sil_swrh_mem(uint16_t *mem, uint16_t data)
+{
+	sil_wrh_mem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+Inline void
+sil_swrh_lem(uint16_t *mem, uint16_t data)
+{
+	sil_wrh_lem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+Inline void
+sil_swrh_bem(uint16_t *mem, uint16_t data)
+{
+	sil_wrh_bem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+/*
+ *  32ビット単位の同期書込み
+ */
+
+Inline void
+sil_swrw_mem(uint32_t *mem, uint32_t data)
+{
+	sil_wrw_mem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+Inline void
+sil_swrw_lem(uint32_t *mem, uint32_t data)
+{
+	sil_wrw_lem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+Inline void
+sil_swrw_bem(uint32_t *mem, uint32_t data)
+{
+	sil_wrw_bem(mem, data);
+	TOPPERS_SIL_WRITE_SYNC();
+}
+
+#endif /* TOPPERS_OMIT_SIL_SYNC_WRITE */
+
 #endif /* TOPPERS_MACRO_ONLY */
 
Index: EcnlProtoTool/trunk/asp3_dcre/include/t_stddef.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/include/t_stddef.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/include/t_stddef.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -113,5 +113,12 @@
 #endif /* UINT64_MAX */
 typedef	uint32_t		PRCTIM;		/* プロセッサ時間［NGKI0573］*/
+#ifndef USE_64BIT_HRTCNT
 typedef	uint32_t		HRTCNT;		/* 高分解能タイマのカウント値 */
+#else /* USE_64BIT_HRTCNT */
+#ifndef UINT64_MAX
+#error 64bit data types are required when USE_64BIT_HRTCNT.
+#endif
+typedef	uint64_t		HRTCNT;		/* 高分解能タイマのカウント値 */
+#endif /* USE_64BIT_HRTCNT */
 
 typedef	TOPPERS_fp		FP;			/* プログラムの起動番地 */
@@ -214,5 +221,6 @@
  */
 #ifndef offsetof
-#define	offsetof(structure, field)	((uintptr_t) &(((structure *) 0)->field))
+#define	offsetof(structure, field) \
+		((uintptr_t)(((char *) &(((structure *) 0)->field)) - ((char *) 0)))
 #endif /* offsetof */
 
Index: EcnlProtoTool/trunk/asp3_dcre/include/t_stdlib.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/include/t_stdlib.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/include/t_stdlib.h	(revision 429)
@@ -61,13 +61,4 @@
 extern const char	*itron_strerror(ER ercd) throw();
 
-/*
- *  エラーメッセージのログ出力
- *
- *  サービスコールがエラーを返した場合に，そのファイル名，行番号，メイ
- *  ンエラーコード等を表示するための関数．
- */
-extern void		t_perror(uint_t prio, const char *file, int_t line,
-									const char *expr, ER ercd) throw();
-
 #ifdef __cplusplus
 }
Index: EcnlProtoTool/trunk/asp3_dcre/include/t_syslog.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/include/t_syslog.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/include/t_syslog.h	(revision 429)
@@ -1,10 +1,9 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -69,4 +68,8 @@
 #include <t_stddef.h>
 
+#ifndef TOPPERS_MACRO_ONLY
+#include <stdarg.h>
+#endif /* TOPPERS_MACRO_ONLY */
+
 /*
  *  ログ情報の種別の定義
@@ -77,6 +80,6 @@
 #define LOG_TYPE_INH		UINT_C(0x11)	/* 割込みハンドラ */
 #define LOG_TYPE_ISR		UINT_C(0x12)	/* 割込みサービスルーチン */
-#define LOG_TYPE_CYC		UINT_C(0x13)	/* 周期ハンドラ */
-#define LOG_TYPE_ALM		UINT_C(0x14)	/* アラームハンドラ */
+#define LOG_TYPE_CYC		UINT_C(0x13)	/* 周期通知 */
+#define LOG_TYPE_ALM		UINT_C(0x14)	/* アラーム通知 */
 #define LOG_TYPE_OVR		UINT_C(0x15)	/* オーバランハンドラ */
 #define LOG_TYPE_EXC		UINT_C(0x16)	/* CPU例外ハンドラ */
@@ -124,61 +127,51 @@
 
 /*
- *  ログ情報の重要度のビットマップを作るためのマクロ
- */
-#define LOG_MASK(prio)		(1U << (prio))
-#define LOG_UPTO(prio)		((1U << ((prio) + 1)) - 1)
-
-/*
- *  パケット形式の定義
- */
-typedef struct t_syslog_rlog {
-	uint_t	count;		/* ログバッファ中のログの数 */
-	uint_t	lost;		/* 失われたログの数 */
-	uint_t	logmask;	/* ログバッファに記録すべき重要度 */
-	uint_t	lowmask;	/* 低レベル出力すべき重要度 */
-} T_SYSLOG_RLOG;
+ *  ログ情報の出力
+ *
+ *  ログ情報の出力は，システムログ機能のアダプタ経由で行う．
+ */
+
+extern ER	syslog_wri_log(uint_t prio, const SYSLOG *p_syslog) throw();
+
+#define syslog_write(prio, p_syslog) \
+						((void) syslog_wri_log(prio, p_syslog))
 
 #ifndef TOPPERS_OMIT_SYSLOG
-
-/*
- *  ログ情報を出力するためのライブラリ関数
- *
- *  TECSで記述されたシステムログ機能を直接呼び出す．
- */
-
-extern ER	tSysLog_eSysLog_write(uint_t prio, const SYSLOG *p_syslog) throw();
-
-Inline void
-_syslog_0(uint_t prio, uint_t type)
-{
-	SYSLOG	logbuf;
-
-	logbuf.logtype = type;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-Inline void
-_syslog_1(uint_t prio, uint_t type, LOGPAR arg1)
-{
-	SYSLOG	logbuf;
-
-	logbuf.logtype = type;
-	logbuf.logpar[0] = arg1;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-Inline void
-_syslog_2(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2)
-{
-	SYSLOG	logbuf;
-
-	logbuf.logtype = type;
-	logbuf.logpar[0] = arg1;
-	logbuf.logpar[1] = arg2;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-Inline void
-_syslog_3(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2, LOGPAR arg3)
+/*
+ *  システムログ出力のための下位のライブラリ関数
+ */
+
+Inline void
+t_syslog_0(uint_t prio, uint_t type)
+{
+	SYSLOG	logbuf;
+
+	logbuf.logtype = type;
+	syslog_write(prio, &logbuf);
+}
+
+Inline void
+t_syslog_1(uint_t prio, uint_t type, LOGPAR arg1)
+{
+	SYSLOG	logbuf;
+
+	logbuf.logtype = type;
+	logbuf.logpar[0] = arg1;
+	syslog_write(prio, &logbuf);
+}
+
+Inline void
+t_syslog_2(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2)
+{
+	SYSLOG	logbuf;
+
+	logbuf.logtype = type;
+	logbuf.logpar[0] = arg1;
+	logbuf.logpar[1] = arg2;
+	syslog_write(prio, &logbuf);
+}
+
+Inline void
+t_syslog_3(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2, LOGPAR arg3)
 {
 	SYSLOG	logbuf;
@@ -188,9 +181,9 @@
 	logbuf.logpar[1] = arg2;
 	logbuf.logpar[2] = arg3;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-Inline void
-_syslog_4(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
+	syslog_write(prio, &logbuf);
+}
+
+Inline void
+t_syslog_4(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
 											LOGPAR arg3, LOGPAR arg4)
 {
@@ -202,9 +195,9 @@
 	logbuf.logpar[2] = arg3;
 	logbuf.logpar[3] = arg4;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-Inline void
-_syslog_5(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
+	syslog_write(prio, &logbuf);
+}
+
+Inline void
+t_syslog_5(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
 								LOGPAR arg3, LOGPAR arg4, LOGPAR arg5)
 {
@@ -217,9 +210,9 @@
 	logbuf.logpar[3] = arg4;
 	logbuf.logpar[4] = arg5;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-Inline void
-_syslog_6(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
+	syslog_write(prio, &logbuf);
+}
+
+Inline void
+t_syslog_6(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
 					LOGPAR arg3, LOGPAR arg4, LOGPAR arg5, LOGPAR arg6)
 {
@@ -233,5 +226,5 @@
 	logbuf.logpar[4] = arg5;
 	logbuf.logpar[5] = arg6;
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
+	syslog_write(prio, &logbuf);
 }
 
@@ -239,8 +232,34 @@
  *  ログ情報（コメント）を出力するためのライブラリ関数（vasyslog.c）
  */
-extern void	syslog(uint_t prio, const char *format, ...) throw();
+extern void	tt_syslog(SYSLOG *p_logbuf, const char *format, va_list ap);
+
+Inline void
+syslog(uint_t prio, const char *format, ...)
+{
+	va_list	ap;
+	SYSLOG	logbuf;
+
+	va_start(ap, format);
+	tt_syslog(&logbuf, format, ap);
+	va_end(ap);
+	syslog_write(prio, &logbuf);
+}
+
+/*
+ *  エラーメッセージを出力するためのライブラリ関数（t_perror.c）
+ */
+extern void	tt_perror(SYSLOG *p_logbuf, const char *file, int_t line,
+		 									const char *expr, ER ercd);
+
+Inline void
+t_perror(uint_t prio, const char *file, int_t line, const char *expr, ER ercd)
+{
+	SYSLOG	logbuf;
+
+	tt_perror(&logbuf, file, line, expr, ercd);
+	syslog_write(prio, &logbuf);
+}
 
 #else /* TOPPERS_OMIT_SYSLOG */
-
 /*
  *  システムログ出力を抑止する場合
@@ -248,25 +267,25 @@
 
 Inline void
-_syslog_0(uint_t prio, uint_t type)
-{
-}
-
-Inline void
-_syslog_1(uint_t prio, uint_t type, LOGPAR arg1)
-{
-}
-
-Inline void
-_syslog_2(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2)
-{
-}
-
-Inline void
-_syslog_3(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2, LOGPAR arg3)
-{
-}
-
-Inline void
-_syslog_4(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
+t_syslog_0(uint_t prio, uint_t type)
+{
+}
+
+Inline void
+t_syslog_1(uint_t prio, uint_t type, LOGPAR arg1)
+{
+}
+
+Inline void
+t_syslog_2(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2)
+{
+}
+
+Inline void
+t_syslog_3(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2, LOGPAR arg3)
+{
+}
+
+Inline void
+t_syslog_4(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
 											LOGPAR arg3, LOGPAR arg4)
 {
@@ -274,5 +293,5 @@
 
 Inline void
-_syslog_5(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
+t_syslog_5(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
 								LOGPAR arg3, LOGPAR arg4, LOGPAR arg5)
 {
@@ -280,5 +299,5 @@
 
 Inline void
-_syslog_6(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
+t_syslog_6(uint_t prio, uint_t type, LOGPAR arg1, LOGPAR arg2,
 					LOGPAR arg3, LOGPAR arg4, LOGPAR arg5, LOGPAR arg6)
 {
@@ -289,9 +308,14 @@
 {
 }
+												
+Inline void
+t_perror(uint_t prio, const char *file, int_t line, const char *expr, ER ercd)
+{
+}
 
 #endif /* TOPPERS_OMIT_SYSLOG */
 
 /*
- *  ログ情報（コメント）を出力するためのマクロ
+ *  システムログ出力のためのライブラリ関数
  *
  *  formatおよび後続の引数から作成したメッセージを，重大度prioでログ情
@@ -301,25 +325,25 @@
 
 #define syslog_0(prio, format) \
-				_syslog_1(prio, LOG_TYPE_COMMENT, (LOGPAR)(format))
+				t_syslog_1(prio, LOG_TYPE_COMMENT, (LOGPAR)(format))
 
 #define syslog_1(prio, format, arg1) \
-				_syslog_2(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
+				t_syslog_2(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
 														(LOGPAR)(arg1))
 
 #define syslog_2(prio, format, arg1, arg2) \
-				_syslog_3(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
+				t_syslog_3(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
 										(LOGPAR)(arg1), (LOGPAR)(arg2))
 
 #define syslog_3(prio, format, arg1, arg2, arg3) \
-				_syslog_4(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
+				t_syslog_4(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
 						(LOGPAR)(arg1), (LOGPAR)(arg2), (LOGPAR)(arg3))
 
 #define syslog_4(prio, format, arg1, arg2, arg3, arg4) \
-				_syslog_5(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
+				t_syslog_5(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
 						(LOGPAR)(arg1), (LOGPAR)(arg2), (LOGPAR)(arg3), \
 														(LOGPAR)(arg4))
 
 #define syslog_5(prio, format, arg1, arg2, arg3, arg4, arg5) \
-				_syslog_6(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
+				t_syslog_6(prio, LOG_TYPE_COMMENT, (LOGPAR)(format), \
 						(LOGPAR)(arg1), (LOGPAR)(arg2), (LOGPAR)(arg3), \
 										(LOGPAR)(arg4), (LOGPAR)(arg5))
@@ -330,5 +354,5 @@
 #ifndef TOPPERS_assert_fail
 #define TOPPERS_assert_fail(exp, file, line) \
-				_syslog_3(LOG_EMERG, LOG_TYPE_ASSERT, (LOGPAR)(file), \
+				t_syslog_3(LOG_EMERG, LOG_TYPE_ASSERT, (LOGPAR)(file), \
 										(LOGPAR)(line), (LOGPAR)(exp))
 #endif /* TOPPERS_assert_fail */
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/Makefile.kernel
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/Makefile.kernel	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/Makefile.kernel	(revision 429)
@@ -6,5 +6,5 @@
 #  Copyright (C) 2003 by Embedded and Real-Time Systems Laboratory
 #                              Toyohashi Univ. of Technology, JAPAN
-#  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -68,6 +68,6 @@
 		wobjwai.o wobjwaitmo.o iniwque.o
 
-time_event = tmeini.o tmeup.o tmedown.o tmecur.o tmeset.o \
-		tmereg.o tmeenq.o tmedeq.o tmechk.o tmeltim.o sigtim.o
+time_event = tmeini.o tmeup.o tmedown.o tmecur.o tmeset.o tmereg.o \
+		tmeenqrel.o tmedeq.o tmechk.o tmeltim.o sigtim.o
 
 task_manage = acre_tsk.o del_tsk.o act_tsk.o can_act.o get_tst.o \
@@ -112,6 +112,6 @@
 		sns_ctx.o sns_loc.o sns_dsp.o sns_dpn.o sns_ker.o
 
-interrupt = isrini.o isrcal.o acre_isr.o del_isr.o \
-		intini.o dis_int.o ena_int.o chg_ipm.o get_ipm.o
+interrupt = isrini.o isrcal.o acre_isr.o del_isr.o intini.o \
+		dis_int.o ena_int.o clr_int.o ras_int.o prb_int.o chg_ipm.o get_ipm.o
 
 exception = excini.o xsns_dpn.o
@@ -120,23 +120,23 @@
 #  生成されるオブジェクトファイルの依存関係の定義
 #
-$(startup) $(startup:.o=.s): startup.c
-$(task) $(task:.o=.s): task.c
-$(taskhook) $(taskhook:.o=.s): taskhook.c
-$(wait) $(wait:.o=.s): wait.c
-$(time_event) $(time_event:.o=.s): time_event.c
-$(task_manage) $(task_manage:.o=.s): task_manage.c
-$(task_refer) $(task_refer:.o=.s): task_refer.c
-$(task_sync) $(task_sync:.o=.s): task_sync.c
-$(task_term) $(task_term:.o=.s): task_term.c
-$(semaphore) $(semaphore:.o=.s): semaphore.c
-$(eventflag) $(eventflag:.o=.s): eventflag.c
-$(dataqueue) $(dataqueue:.o=.s): dataqueue.c
-$(pridataq) $(pridataq:.o=.s): pridataq.c
-$(mutex) $(mutex:.o=.s): mutex.c
-$(mempfix) $(mempfix:.o=.s): mempfix.c
-$(time_manage) $(time_manage:.o=.s): time_manage.c
-$(cyclic) $(cyclic:.o=.s): cyclic.c
-$(alarm) $(alarm:.o=.s): alarm.c
-$(sys_manage) $(sys_manage:.o=.s): sys_manage.c
-$(interrupt) $(interrupt:.o=.s): interrupt.c
-$(exception) $(exception:.o=.s): exception.c
+$(addprefix $(OBJDIR)/, $(startup)) $(startup:.o=.s): startup.c
+$(addprefix $(OBJDIR)/, $(task)) $(task:.o=.s): task.c
+$(addprefix $(OBJDIR)/, $(taskhook)) $(taskhook:.o=.s): taskhook.c
+$(addprefix $(OBJDIR)/, $(wait)) $(wait:.o=.s): wait.c
+$(addprefix $(OBJDIR)/, $(time_event)) $(time_event:.o=.s): time_event.c
+$(addprefix $(OBJDIR)/, $(task_manage)) $(task_manage:.o=.s): task_manage.c
+$(addprefix $(OBJDIR)/, $(task_refer)) $(task_refer:.o=.s): task_refer.c
+$(addprefix $(OBJDIR)/, $(task_sync)) $(task_sync:.o=.s): task_sync.c
+$(addprefix $(OBJDIR)/, $(task_term)) $(task_term:.o=.s): task_term.c
+$(addprefix $(OBJDIR)/, $(semaphore)) $(semaphore:.o=.s): semaphore.c
+$(addprefix $(OBJDIR)/, $(eventflag)) $(eventflag:.o=.s): eventflag.c
+$(addprefix $(OBJDIR)/, $(dataqueue)) $(dataqueue:.o=.s): dataqueue.c
+$(addprefix $(OBJDIR)/, $(pridataq)) $(pridataq:.o=.s): pridataq.c
+$(addprefix $(OBJDIR)/, $(mutex)) $(mutex:.o=.s): mutex.c
+$(addprefix $(OBJDIR)/, $(mempfix)) $(mempfix:.o=.s): mempfix.c
+$(addprefix $(OBJDIR)/, $(time_manage)) $(time_manage:.o=.s): time_manage.c
+$(addprefix $(OBJDIR)/, $(cyclic)) $(cyclic:.o=.s): cyclic.c
+$(addprefix $(OBJDIR)/, $(alarm)) $(alarm:.o=.s): alarm.c
+$(addprefix $(OBJDIR)/, $(sys_manage)) $(sys_manage:.o=.s): sys_manage.c
+$(addprefix $(OBJDIR)/, $(interrupt)) $(interrupt:.o=.s): interrupt.c
+$(addprefix $(OBJDIR)/, $(exception)) $(exception:.o=.s): exception.c
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/alarm.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/alarm.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/alarm.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -164,6 +164,6 @@
 	ALMINIB		*p_alminib;
 	ATR			almatr;
-	T_NFYINFO	nfyinfo, *p_nfyinfo;
-	ER			ercd, rercd;
+	T_NFYINFO	*p_nfyinfo;
+	ER			ercd;
 
 	LOG_ACRE_ALM_ENTER(pk_calm);
@@ -171,10 +171,8 @@
 
 	almatr = pk_calm->almatr;
-	nfyinfo = pk_calm->nfyinfo;
-
-	CHECK_RSATR(almatr, TA_NULL);
-	rercd = check_nfyinfo(&nfyinfo);
-	if (rercd != E_OK) {
-		ercd = rercd;
+
+	CHECK_VALIDATR(almatr, TA_NULL);
+	ercd = check_nfyinfo(&(pk_calm->nfyinfo));
+	if (ercd != E_OK) {
 		goto error_exit;
 	}
@@ -189,11 +187,11 @@
 		p_alminib = (ALMINIB *)(p_almcb->p_alminib);
 		p_alminib->almatr = almatr;
-		if (nfyinfo.nfymode == TNFY_HANDLER) {
-			p_alminib->exinf = nfyinfo.nfy.handler.exinf;
-			p_alminib->nfyhdr = (NFYHDR)(nfyinfo.nfy.handler.tmehdr);
+		if (pk_calm->nfyinfo.nfymode == TNFY_HANDLER) {
+			p_alminib->exinf = pk_calm->nfyinfo.nfy.handler.exinf;
+			p_alminib->nfyhdr = (NFYHDR)(pk_calm->nfyinfo.nfy.handler.tmehdr);
 		}
 		else {
 			p_nfyinfo = &aalm_nfyinfo_table[p_alminib - aalminib_table];
-			*p_nfyinfo = nfyinfo;
+			*p_nfyinfo = pk_calm->nfyinfo;
 			p_alminib->exinf = (intptr_t) p_nfyinfo;
 			p_alminib->nfyhdr = notify_handler;
@@ -283,5 +281,5 @@
 			p_almcb->almsta = true;
 		}
-		tmevtb_enqueue(&(p_almcb->tmevtb), almtim);
+		tmevtb_enqueue_reltim(&(p_almcb->tmevtb), almtim);
 		ercd = E_OK;
 	}
@@ -385,4 +383,7 @@
 	/*
 	 *  通知ハンドラを，CPUロック解除状態で呼び出す．
+	 *
+	 *  アラーム通知の生成／削除はタスクからしか行えないため，アラーム
+	 *  通知初期化ブロックをCPUロック解除状態で参照しても問題ない．
 	 */
 	unlock_cpu();
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/alarm.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/alarm.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/alarm.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -52,7 +52,7 @@
 
   def prepare(key, params)
-    # almatrが無効の場合（E_RSATR）［NGKI2491］
-    #（TA_STA以外のビットがセットされている場合）
-    if (params[:almatr] & ~($TA_STA)) != 0
+    # almatrが無効の場合（E_RSATR）［NGKI2491］［NGKI3423］［NGKI3424］
+    #（TA_NULLでない場合）
+    if (params[:almatr] != $TA_NULL)
       error_illegal_id("E_RSATR", params, :almatr, :almid)
     end
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/allfunc.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/allfunc.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/allfunc.h	(revision 429)
@@ -4,5 +4,5 @@
  *      Advanced Standard Profile Kernel
  * 
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -81,5 +81,5 @@
 #define TOPPERS_tmeset
 #define TOPPERS_tmereg
-#define TOPPERS_tmeenq
+#define TOPPERS_tmeenqrel
 #define TOPPERS_tmedeq
 #define TOPPERS_tmechk
@@ -257,4 +257,7 @@
 #define TOPPERS_dis_int
 #define TOPPERS_ena_int
+#define TOPPERS_clr_int
+#define TOPPERS_ras_int
+#define TOPPERS_prb_int
 #define TOPPERS_chg_ipm
 #define TOPPERS_get_ipm
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/check.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/check.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/check.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -65,15 +65,4 @@
 
 /*
- *  オブジェクト番号の範囲の判定
- */
-#ifndef VALID_INTNO_DISINT
-#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
-#endif /* VALID_INTNO_DISINT */
-
-#ifndef VALID_INTNO_CREISR
-#define VALID_INTNO_CREISR(intno)    VALID_INTNO(intno)
-#endif /* VALID_INTNO_CREISR */
-
-/*
  *  優先度の範囲の判定
  */
@@ -85,9 +74,4 @@
 				(TMIN_ISRPRI <= (isrpri) && (isrpri) <= TMAX_ISRPRI)
 
-#ifndef VALID_INTPRI_CHGIPM
-#define VALID_INTPRI_CHGIPM(intpri) \
-				(TMIN_INTPRI <= (intpri) && (intpri) <= TIPM_ENAALL)
-#endif /* VALID_INTPRI_CHGIPM */
-
 /*
  *  相対時間の範囲の判定
@@ -98,6 +82,5 @@
  *  タイムアウト指定値の範囲の判定
  */
-#define VALID_TMOUT(tmout)	((tmout) <= TMAX_RELTIM || (tmout) == TMO_FEVR \
-													|| (tmout) == TMO_POL)
+#define VALID_TMOUT(tmout)	((tmout) <= TMAX_RELTIM || (tmout) == TMO_FEVR)
 
 /*
@@ -208,5 +191,5 @@
 
 /*
- *  オブジェクトIDのチェック（E_ID）
+ *  不正ID番号のチェック（E_ID）
  */
 #define CHECK_ID(exp) do {									\
@@ -218,7 +201,7 @@
 
 /*
- *  予約属性エラーのチェック（E_RSATR）
- */
-#define CHECK_RSATR(atr, valid_atr) do {					\
+ *  属性が無効なビットが立っていないかのチェック（E_RSATR）
+ */
+#define CHECK_VALIDATR(atr, valid_atr) do {					\
 	if (((atr) & ~(valid_atr)) != 0U) {						\
 		ercd = E_RSATR;										\
@@ -238,5 +221,5 @@
 
 /*
- *  不正使用エラーのチェック（E_ILUSE）
+ *  サービスコール不正使用のチェック（E_ILUSE）
  */
 #define CHECK_ILUSE(exp) do {								\
@@ -248,5 +231,5 @@
 
 /*
- *  静的なオブジェクト状態エラーのチェック（E_OBJ）
+ *  オブジェクト状態エラーのチェック（E_OBJ）
  */
 #define CHECK_OBJ(exp) do {									\
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/cyclic.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/cyclic.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/cyclic.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -175,8 +175,7 @@
 	CYCINIB		*p_cycinib;
 	ATR			cycatr;
-	T_NFYINFO	nfyinfo, *p_nfyinfo;
-	RELTIM		cyctim;
-	RELTIM		cycphs;
-	ER			ercd, rercd;
+	RELTIM		cyctim, cycphs;
+	T_NFYINFO	*p_nfyinfo;
+	ER			ercd;
 
 	LOG_ACRE_CYC_ENTER(pk_ccyc);
@@ -184,12 +183,10 @@
 
 	cycatr = pk_ccyc->cycatr;
-	nfyinfo = pk_ccyc->nfyinfo;
 	cyctim = pk_ccyc->cyctim;
 	cycphs = pk_ccyc->cycphs;
 
-	CHECK_RSATR(cycatr, TA_STA);
-	rercd = check_nfyinfo(&nfyinfo);
-	if (rercd != E_OK) {
-		ercd = rercd;
+	CHECK_VALIDATR(cycatr, TA_STA);
+	ercd = check_nfyinfo(&(pk_ccyc->nfyinfo));
+	if (ercd != E_OK) {
 		goto error_exit;
 	}
@@ -206,11 +203,11 @@
 		p_cycinib = (CYCINIB *)(p_cyccb->p_cycinib);
 		p_cycinib->cycatr = cycatr;
-		if (nfyinfo.nfymode == TNFY_HANDLER) {
-			p_cycinib->exinf = nfyinfo.nfy.handler.exinf;
-			p_cycinib->nfyhdr = (NFYHDR)(nfyinfo.nfy.handler.tmehdr);
+		if (pk_ccyc->nfyinfo.nfymode == TNFY_HANDLER) {
+			p_cycinib->exinf = pk_ccyc->nfyinfo.nfy.handler.exinf;
+			p_cycinib->nfyhdr = (NFYHDR)(pk_ccyc->nfyinfo.nfy.handler.tmehdr);
 		}
 		else {
 			p_nfyinfo = &acyc_nfyinfo_table[p_cycinib - acycinib_table];
-			*p_nfyinfo = nfyinfo;
+			*p_nfyinfo = pk_ccyc->nfyinfo;
 			p_cycinib->exinf = (intptr_t) p_nfyinfo;
 			p_cycinib->nfyhdr = notify_handler;
@@ -221,5 +218,6 @@
 		if ((p_cyccb->p_cycinib->cycatr & TA_STA) != 0U) {
 			p_cyccb->cycsta = true;
-			tmevtb_enqueue(&(p_cyccb->tmevtb), p_cyccb->p_cycinib->cycphs);
+			tmevtb_enqueue_reltim(&(p_cyccb->tmevtb),
+										p_cyccb->p_cycinib->cycphs);
 		}
 		else {
@@ -311,5 +309,5 @@
 		 *  初回の起動のためのタイムイベントを登録する［ASPD1036］．
 		 */
-		tmevtb_enqueue(&(p_cyccb->tmevtb), p_cyccb->p_cycinib->cycphs);
+		tmevtb_enqueue_reltim(&(p_cyccb->tmevtb), p_cyccb->p_cycinib->cycphs);
 		ercd = E_OK;
 	}
@@ -414,4 +412,7 @@
 	/*
 	 *  通知ハンドラを，CPUロック解除状態で呼び出す．
+	 *
+	 *  周期通知の生成／削除はタスクからしか行えないため，周期通知初期
+	 *  化ブロックをCPUロック解除状態で参照しても問題ない．
 	 */
 	unlock_cpu();
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/cyclic.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/cyclic.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/cyclic.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -52,5 +52,5 @@
 
   def prepare(key, params)
-    # cycatrが無効の場合（E_RSATR）［NGKI2383］
+    # cycatrが無効の場合（E_RSATR）［NGKI2383］［NGKI2370］［ASPS0172］
     #（TA_STA以外のビットがセットされている場合）
     if (params[:cycatr] & ~($TA_STA)) != 0
@@ -58,10 +58,12 @@
     end
 
-    # (0 < cyctim && cyctim <= TMAX_RELTIM)でない場合（E_PAR）［NGKI2397］
+    # cyctimが有効範囲外の場合（E_PAR）［NGKI2397］
+    #（0 < cyctim && cyctim <= TMAX_RELTIMでない場合）
     if !(0 < params[:cyctim] && params[:cyctim] <= $TMAX_RELTIM)
       error_illegal_id("E_PAR", params, :cyctim, :cycid)
     end
 
-    # (0 <= cycphs && cycphs <= TMAX_RELTIM)でない場合（E_PAR）［NGKI2399］
+    # cycphsが有効範囲外の場合（E_PAR）［NGKI2399］
+    #（0 <= cycphs && cycphs <= TMAX_RELTIMでない場合）
     if !(0 <= params[:cycphs] && params[:cycphs] <= $TMAX_RELTIM)
       error_illegal_id("E_PAR", params, :cycphs, :cycid)
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/dataqueue.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/dataqueue.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/dataqueue.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -356,5 +356,8 @@
 	p_dtqmb = pk_cdtq->dtqmb;
 
-	CHECK_RSATR(dtqatr, TA_TPRI);
+	CHECK_VALIDATR(dtqatr, TA_TPRI);
+	if (p_dtqmb != NULL) {
+		CHECK_PAR(MB_ALIGN(p_dtqmb));
+	}
 
 	lock_cpu();
@@ -364,5 +367,5 @@
 	else {
 		if (dtqcnt != 0 && p_dtqmb == NULL) {
-			p_dtqmb = kernel_malloc(sizeof(DTQMB) * dtqcnt);
+			p_dtqmb = malloc_mpk(sizeof(DTQMB) * dtqcnt);
 			dtqatr |= TA_MBALLOC;
 		}
@@ -423,5 +426,5 @@
 		p_dtqinib = (DTQINIB *)(p_dtqcb->p_dtqinib);
 		if ((p_dtqinib->dtqatr & TA_MBALLOC) != 0U) {
-			kernel_free(p_dtqinib->p_dtqmb);
+			free_mpk(p_dtqinib->p_dtqmb);
 		}
 		p_dtqinib->dtqatr = TA_NOEXS;
@@ -449,7 +452,7 @@
 snd_dtq(ID dtqid, intptr_t data)
 {
-	DTQCB	*p_dtqcb;
-	WINFO_SDTQ winfo_sdtq;
-	ER		ercd;
+	DTQCB		*p_dtqcb;
+	WINFO_SDTQ	winfo_sdtq;
+	ER			ercd;
 
 	LOG_SND_DTQ_ENTER(dtqid, data);
@@ -473,6 +476,6 @@
 	else {
 		winfo_sdtq.data = data;
-		p_runtsk->tstat = TS_WAITING_SDTQ;
-		wobj_make_wait((WOBJCB *) p_dtqcb, (WINFO_WOBJ *) &winfo_sdtq);
+		wobj_make_wait((WOBJCB *) p_dtqcb, TS_WAITING_SDTQ,
+											(WINFO_WOBJ *) &winfo_sdtq);
 		dispatch();
 		ercd = winfo_sdtq.winfo.wercd;
@@ -513,5 +516,5 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
@@ -538,8 +541,8 @@
 tsnd_dtq(ID dtqid, intptr_t data, TMO tmout)
 {
-	DTQCB	*p_dtqcb;
-	WINFO_SDTQ winfo_sdtq;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	DTQCB		*p_dtqcb;
+	WINFO_SDTQ	winfo_sdtq;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TSND_DTQ_ENTER(dtqid, data, tmout);
@@ -567,7 +570,6 @@
 	else {
 		winfo_sdtq.data = data;
-		p_runtsk->tstat = TS_WAITING_SDTQ;
-		wobj_make_wait_tmout((WOBJCB *) p_dtqcb, (WINFO_WOBJ *) &winfo_sdtq,
-														&tmevtb, tmout);
+		wobj_make_wait_tmout((WOBJCB *) p_dtqcb, TS_WAITING_SDTQ,
+								(WINFO_WOBJ *) &winfo_sdtq, &tmevtb, tmout);
 		dispatch();
 		ercd = winfo_sdtq.winfo.wercd;
@@ -612,8 +614,8 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
-	ercd = E_OK;
+		ercd = E_OK;
 	}
 	unlock_cpu();
@@ -634,7 +636,7 @@
 rcv_dtq(ID dtqid, intptr_t *p_data)
 {
-	DTQCB	*p_dtqcb;
-	WINFO_RDTQ winfo_rdtq;
-	ER		ercd;
+	DTQCB		*p_dtqcb;
+	WINFO_RDTQ	winfo_rdtq;
+	ER			ercd;
 
 	LOG_RCV_DTQ_ENTER(dtqid, p_data);
@@ -657,6 +659,5 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_RDTQ;
-		make_wait(&(winfo_rdtq.winfo));
+		make_wait(TS_WAITING_RDTQ, &(winfo_rdtq.winfo));
 		queue_insert_prev(&(p_dtqcb->rwait_queue), &(p_runtsk->task_queue));
 		winfo_rdtq.p_dtqcb = p_dtqcb;
@@ -723,8 +724,8 @@
 trcv_dtq(ID dtqid, intptr_t *p_data, TMO tmout)
 {
-	DTQCB	*p_dtqcb;
-	WINFO_RDTQ winfo_rdtq;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	DTQCB		*p_dtqcb;
+	WINFO_RDTQ	winfo_rdtq;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TRCV_DTQ_ENTER(dtqid, p_data, tmout);
@@ -751,6 +752,5 @@
 	}
 	else {
-		p_runtsk->tstat = TS_WAITING_RDTQ;
-		make_wait_tmout(&(winfo_rdtq.winfo), &tmevtb, tmout);
+		make_wait_tmout(TS_WAITING_RDTQ, &(winfo_rdtq.winfo), &tmevtb, tmout);
 		queue_insert_prev(&(p_dtqcb->rwait_queue), &(p_runtsk->task_queue));
 		winfo_rdtq.p_dtqcb = p_dtqcb;
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/dataqueue.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/dataqueue.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/dataqueue.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -54,5 +54,5 @@
     params[:dtqmb] ||= "NULL"
 
-    # dtqatrが無効の場合（E_RSATR）［NGKI1669］
+    # dtqatrが無効の場合（E_RSATR）［NGKI1669］［NGKI1661］
     #（TA_TPRI以外のビットがセットされている場合）
     if (params[:dtqatr] & ~($TA_TPRI)) != 0
